import React, {PureComponent} from 'react';
import SortableTree from './index.esm'
import './style.css';

import {TreeExchanger} from './exchanger'

export default class Tree extends PureComponent {

    SearchSelectedNode(node)
    {
        if(node.selected)
        {
          this.SelectedNodes.push(node);
        }
        for(let i of node.children)
        {
          this.SearchSelectedNode(i);
        }
    }
  
    RemoveSelectedTagFromAllNodes(node)
    {
        node.selected = false;
        for(let i of node.children)
        {
          this.RemoveSelectedTagFromAllNodes(i);
        }
    }
  
    DeleteLabeled(node)
    {
      for(let i = 0; i < node.children.length; i++)
      {
        if(node.children[i].deleted)
        {
          node.children.splice(i,1);
          i--;
        }
        else
        {
         this.DeleteLabeled(node.children[i])
        }
      }
    }
  
    Replace(node)
    {
      if(!this.SelectedNodes) return false;
      for(let i of this.SelectedNodes)
      {
        Object.assign(i,node);
      }
      let x = JSON.stringify(this.treeData);
      this.treeData = JSON.parse(x);
      this.SelectedNodeUpdateRequired = true;
      this.forceUpdate();
      return true;
    }
  
  
    constructor(props) {
      super(props);
  
      this.SelectedNodes = [];
  
        this.treeData= 
        [
          { 
            id:new Date().getUTCMilliseconds(),
            ...this.props.rootNode,
            children: [] ,  
            expanded:true,
            selected: true
          },
        ];
  
        this.Counter = 0;
        TreeExchanger.onTreeItemSelected = (node, ctrlKey)=>
        {
          if(ctrlKey === false)
          {
            this.RemoveSelectedTagFromAllNodes(this.treeData[0])
          }
          
          node.selected = true;
  
          this.SelectedNodes = [];
          this.SearchSelectedNode(this.treeData[0])
          this.onNodesSelect(this.SelectedNodes);
  
  
          let x = JSON.stringify(this.treeData);
          this.treeData = JSON.parse(x);
          this.forceUpdate();
        }
  
        (()=>{this.props.getAddFunc(this.AddNode)})();
        this.props.getDeleteFunc(this.DeleteNode);
  
        this.onNodesSelect = this.props.onNodesSelect;
  
    }
  
  
  
    DeleteNode(){
      for(let value of this.SelectedNodes) 
      {
        value.deleted = true;
      }
      this.DeleteLabeled(this.treeData[0]);
      
      let x = JSON.stringify(this.treeData);
      this.treeData = JSON.parse(x);
      this.SelectedNodeUpdateRequired = true;
      this.forceUpdate();
      
    }
  
    AddNode(){
      for(let value of this.SelectedNodes) 
      {
        value.children.push({ 
          id:new Date().getUTCMilliseconds(),
          ...this.props.addNodePattern,
          children: [],
          expanded:true,
        })
        value.expanded = true;
      }
  
     let x = JSON.stringify(this.treeData);
     this.treeData = JSON.parse(x);
     this.SelectedNodeUpdateRequired = true;
     this.forceUpdate();
    }
  
   
    render() {
  
      console.log("render...")
      this.SelectedNodes = [];
      this.SearchSelectedNode(this.treeData[0])
      if(this.SelectedNodeUpdateRequired)
      {
        this.SelectedNodeUpdateRequired = false;
        this.onNodesSelect(this.SelectedNodes);
      }
      
      return (
          <SortableTree 
            ref={this.refx}
            treeData={this.treeData}
            onChange={treeData => 
              {
                if(treeData.length === 1)
                this.treeData = treeData; this.forceUpdate()
              }}
          />
      );
    }
  }